(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* Only TranslateP2C and TranslateC2P need to be used directly. *)

(* Results in the set of rules referenced by the rules -> {...} element of the Plenum grammar *)
ExtractRules = Grammar[___, rules-> rules_, ___] -> rules ;
(* Results in everything within the Grammar head that isn't part of the rules element *)
ExtractNonruleInfo = Grammar[pre: Longest[Except[rules -> _]...], rules-> rules_, post: Longest[Except[rules -> _]...]] -> GrammarParameters[pre, post] ;

(* Rule-by-rule translation from Plenum grammar rules to Cambium arrows.  Each Plenum rule will be transformed into exactly one Cambium arrow. *)
RuleTranslateP2C = {
(* transforms rules containing a With clause but not a Solving clause.  *)
{pre___, lhs_ -> rhs_, preWith: Longest[Except[(solving[__]| with[___] |  (_ -> _ )| CambiumArrow[___]), ratePre_[___]]...], withClause: with[_], postWith: Longest[Except[(solving[__] | (_ -> _ )| CambiumArrow[___]), ratePost_[___]]...], post___} :> {pre, CambiumArrow[DynGram[discrete, rule], Flatten[{lhs}], {}, Flatten[{rhs}], {preWith, withClause, postWith}], post},
(* transforms rules containing a Solving clause but not a With clause *)
{pre___, lhs_ -> rhs_, preSolving: Longest[Except[(with[__] | solving[___] | (_ -> _) | CambiumArrow[___]), ratePre_[___]]...], solvingClause: solving[__], postSolving: Longest[Except[(with[_] | (_ -> _ )| CambiumArrow[___]), ratePost_[___]]...], post___} :> {pre, CambiumArrow[DynGram[continuous, rule], Flatten[{lhs}], {}, Flatten[{rhs}], {preSolving, solvingClause, postSolving}], post},
(* Transforms rules with rate clauses, where no such rate clause is With or Solving *)
{pre___, lhs_ -> rhs_, rateClauses : Longest[Except[(with[__] | solving[___] | (_ -> _) | CambiumArrow[___]), _[___]]...], post___} :> {pre, CambiumArrow[DynGram[rule], Flatten[{lhs}], {}, Flatten[{rhs}], Flatten[{rateClauses}]], post},
(* Transforms rules with no rate clauses at all.  This transformation must have a lower precedence than the others, so it is last in the list. *)
(lhs_ -> rhs_) :> CambiumArrow[DynGram[rule], Flatten[{lhs}], {}, Flatten[{rhs}], {}] 
};
(* Rule-by-rule translation from Cambium arrows to Plenum grammar rules.  Each Cambium arrow will transformed into exactly one Plenum rule. The MHS should already be emptied using contantTermsFromMhs - TranslateC2P takes care of this.  *)
RuleTranslateC2P = {
(* transforms rules without rate clauses *)
(CambiumArrow[DynGram[___, rule, ___], lhs_, {}, rhs_, {}]) :> (lhs -> rhs), 
(* transforms rules with rate clauses *)
{pre___, (CambiumArrow[DynGram[___, rule, ___], lhs_, {}, rhs_, {rateInfo: (with[_] | solving[__] | subjectTo[__])..}]), post___} :> {pre, lhs -> rhs, rateInfo, post}, 
(* if single items appear on the LHS or RHS of a rule, they can appear inside a (singleton) list or without a list.  These transformations enforce output consistency by outputting all single items without a list *)
({singleton_} -> rhs_)-> (singleton -> rhs), 
(lhs_ -> {singleton_}) -> (lhs -> singleton)
} ;

(* Cambium has a MHS but Plenum doesn't, so when translating from Plenum to Cambium, any LHS/RHS-identical elements can be put in the MHS. *)
constantTermsToMhs = 
CambiumArrow[(dgType: Except[DynGram[___, (continuous | composite), ___], DynGram[___, discrete, ___]]), {lhsPre___, identicalElt_, lhsPost___}, mhs_List, {rhsPre___, identicalElt_, rhsPost___}, (clauses: Except[{___, solving[___], ___}, {___, with[___], ___}])] :> 
CambiumArrow[dgType, {lhsPre, lhsPost}, Prepend[mhs, identicalElt], {rhsPre, rhsPost}, clauses];
(* Since Plenum doesn't have a MHS, all MHS elements should appear as identical copies on the LHS and RHS *)
constantTermsFromMhs = CambiumArrow[(dgType: Except[DynGram[___, (continuous | composite), ___], DynGram[___, discrete, ___]]), lhs_, (mhs: {__}), rhs_, (clauses: Except[{___, solving[___], ___}, {___, with[___], ___}])] :> CambiumArrow[dgType, Flatten[Prepend[lhs, mhs]], {}, Flatten[Prepend[rhs, mhs]], clauses];

(* Overall Plenum<-->Cambium translations, and the only transformations that need to be used directly.  These transformations ensure proper ordering and application of the lower-level transformations defined above *)
(* Plenum to Cambium *)
TranslateP2C = (grammar: Grammar[___]) :> 
(* overall container for individual reaction arrows is a composite arrow *)
CambiumArrow[DynGram[composite], {}, {}, {}, 
(* all non-rule Grammar elements put inside a GrammarParameters head *) 
{(grammar /. ExtractNonruleInfo), 
(* rule-by-rule translation is applied to the grammar's rule list, then Cambium/non-Plenum features are exploited (currently just unchanged terms in the MHS) *)
(grammar /. ExtractRules //. RuleTranslateP2C //. constantTermsToMhs) //. 
(* then put the rules in a Rules header rather than a List header *)(List[arrows: Longest[CambiumArrow[__]..]] -> Rules[arrows])} ];
(* Cambium to Plenum *)
TranslateC2P = 
(* recognize the container as a Cambium arrow with DynGram type and a composite-attribute *)(CambiumArrow[DynGram[___, composite, ___], _, _, _, 
(* match and name the parameters, if any *)
{parameters: (GrammarParameters[params___] | PatternSequence[]), 
(* match and name the reaction arrows *)
(arrows: Rules[CambiumArrow[DynGram[___, rule, ___], _, _, _, _]..])} ]) :> 
(* put the parameters at the beginning.  For the rules, change back to a List (from the Rules header in Cambium), remove any Cambium/non-Plenum features (right now, this is just copying MHS terms to the LHS and RHS), then apply rule-by-rule translation *)Grammar[params, rules -> (arrows //.(Rules -> List) //. constantTermsFromMhs //. RuleTranslateC2P )];
